<template>
  <div class="p-4">
    <h1>Gebouw detail</h1>
    <div class="row justify-content-between mb-5">
      <div class="col-12 col-lg-6 drop-shadow border-radius p-4">
        <div class="row">
          <div class="col-12 mb-2">
            <div class="row">
              <img
                :src="
                  buildingData?.image?.originalUrl
                    ? '/api/image?name=test.png&uri=' +
                      buildingData.image.originalUrl
                    : 'https://www.odisee.be/sites/default/files/public/styles/media_paragraph_image/public/2021-06/Snuif%20de%20sfeer%20op%2018.JPG?itok=68dTHQ_L'
                "
                class="route-image"
                alt="..."
              />
              <MapBox id="map" :location="buildingData"></MapBox>
            </div>
          </div>
          <div class="col-12 d-flex justify-content-between align-items-center">
            <h3>{{ this.buildingData.name }}</h3>
            <div class="point">
              <Icon @click="editBuilding()" class="icons" icon="bx:edit" />
              <Icon
                v-if="!this.confirm"
                @click="confirmate()"
                class="icons"
                color="red"
                icon="pajamas:remove"
              />
              <Icon
                v-if="this.confirm"
                @click="deleteBuilding()"
                class="icons"
                icon="line-md:confirm"
                color="red"
              />
            </div>
          </div>
          <div class="col-12 d-flex-column align-items-center">
            <div class="d-flex align-items-center">
              <div class="h5 me-1">Adres</div>
              <div>
                {{ splitAddress(this.buildingData.address).streetAndNumber }}
              </div>
            </div>
            <div class="d-flex align-items-center">
              <div class="h5 me-1">Stad</div>
              <div>
                {{ this.buildingData.zip }} {{ this.buildingData.city }}
              </div>
            </div>
            <div class="d-flex align-items-center mb-1">
              <div class="h5 me-1">Route</div>
              <div>{{ this.buildingData.round.name }}</div>
            </div>
            <div class="d-flex align-items-center">
              <div>{{ this.buildingData.description }}</div>
            </div>
          </div>
        </div>
      </div>

      <div class="col-12 col-lg-6 drop-shadow border-radius p-4">
        <h3>Codes</h3>
        <div>
          <div
            class="row p-1 pt-2 building-item"
            v-for="(code, index) in codes"
            :class="activeStepIndexCodes == index ? 'active-building' : ''"
            :key="index"
            @click="activeStepIndexCodes = index"
          >
            <div class="col flex-column py-2">
              <h4 v-html="code.title"></h4>
              <div class="mb-2" v-if="activeStepIndexCodes == index">
                {{ code.body }}
              </div>
            </div>
            <div
              v-if="activeStepIndexCodes == index"
              class="col-1 col-md-2 d-flex justify-content-end"
            >
              edit
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="row justify-content-between mb-5">
      <!-- <div class="col-10 col-lg-7 drop-shadow border-radius p-4">
        <h3 class="mb-4">Opmerkingen</h3>
        <div class="row tab-filter mb-4">
          <div
            class="col-6 col-lg-2 text-center tab-filter__tab px-2"
            :class="activeFilter == 'conflict' ? 'active' : ''"
            @click="activeFilter = 'conflict'"
          >
            Conflict
          </div>
          <div
            class="col-6 col-lg-2 text-center tab-filter__tab px-2"
            :class="activeFilter == 'solved' ? 'active' : ''"
            @click="activeFilter = 'solved'"
          >
            Opgelost
          </div>
        </div>
        <div>
          <div
            v-for="(remark, index) in filteredRemarks"
            :key="index"
            class="mb-4"
          >
            <div class="row align-items-center mb-3">
              <img :src="users[remark.user_id].image" class="profile-picture" />
              <div class="col d-flex">
                <div>{{ users[remark.user_id].student }}</div>
                <div class="text-gray">- 1hrs Ago</div>
              </div>
            </div>
            <div class="remark border-radius p-3 mb-2">
              {{ remark.body }}
            </div>
            <div v-if="remark.comments">
              <div
                v-for="(comment, commentIndex) in remark.comments"
                :key="commentIndex"
              >
                <div class="border-radius p-3 mb-2 ms-5">
                  <div class="row align-items-center mb-3">
                    <img
                      :src="users[comment.user_id].image"
                      class="profile-picture__small"
                    />
                    <div class="col d-flex">
                      <div>{{ users[comment.user_id].student }}</div>
                      <div class="text-gray">- 10m Ago</div>
                    </div>
                  </div>
                  <div class="remark border-radius p-3 mb-2">
                    {{ comment.body }}
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div> -->
      <div class="col-12 col-lg-5 drop-shadow border-radius p-4">
        <h3>Instructies</h3>
        <div class="d-flex aling-items-center mb-4">
          <ProgressTracker
            :tabs="instructions"
            :tabIndex="activeStepIndex"
            class="w-100"
          />
        </div>
        <div>
          <div
            class="row p-1 pt-2 building-item"
            v-for="(instruction, index) in instructions"
            :class="activeStepIndex == index ? 'active-building' : ''"
            :key="index"
            @click="activeStepIndex = index"
          >
            <div class="col flex-column py-2">
              <h4 v-html="instruction.title"></h4>
              <div class="mb-2" v-if="activeStepIndex == index">
                {{ instruction.body }}
              </div>
            </div>
            <div
              v-if="activeStepIndex == index"
              class="col-1 col-md-2 d-flex justify-content-end"
            >
              edit
            </div>
          </div>
        </div>
      </div>

      <div class="col-12 col-lg-7 drop-shadow border-radius p-4">
        <h3 class="mb-3">Getrokken Foto's</h3>
        <div class="images-container row">
          <div
            v-for="(image, index) in items"
            :key="image"
            class="col-4 border-radius p-1"
          >
            <div v-if="index < 9">
              <img :src="image.url" class="img-fluid" />
              <div class="d-flex">
                <div class="upload pe-1">Upload datum</div>
                {{ image.date.toLocaleString() }}
              </div>
            </div>
          </div>
          <p v-if="items.length == 0">Nog geen images geüpload vandaag</p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ProgressTracker from "./organisms/ProgressTracker.vue";
import MapBox from "./molecules/MapBox.vue";
import axios from "axios";
import store from "@/store/auth";
import { Icon } from "@iconify/vue";

export default {
  components: { ProgressTracker, MapBox, Icon },
  data() {
    return {
      confirm: false,
      buildingData: {},
      users: [
        {
          id: 25168,
          student: "Suup R. Student",
          route: "Hoog-gent",
          stad: "Gent",
          status: "40%",
          opmerking: 2,
          opmerkingDetail: "",
          image:
            "https://images.unsplash.com/photo-1599566150163-29194dcaad36?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxwaG90by1wYWdlfHx8fGVufDB8fHx8&auto=format&fit=crop&w=687&q=80",
          role: "1",
        },
        {
          id: 25169,
          student: "Bob D. Bouwer",
          route: "Laag-gent",
          stad: "Gent",
          status: "54%",
          opmerking: 0,
          opmerkingDetail: "",
          image:
            "https://images.unsplash.com/photo-1544723795-3fb6469f5b39?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxwaG90by1wYWdlfHx8fGVufDB8fHx8&auto=format&fit=crop&w=689&q=80",
          role: "3",
        },
        {
          id: 25170,
          student: "Rick Astley",
          route: "'t Zuid",
          stad: "Antwerpen",
          status: "79%",
          opmerking: 0,
          opmerkingDetail: "",
          image:
            "https://i1.sndcdn.com/artworks-000094489636-qzznk3-t500x500.jpg",
          role: "3",
        },
        {
          id: 25168,
          student: "Waldo Waaris",
          route: "Hoog-gent",
          stad: "Gent",
          status: "20%",
          opmerking: 2,
          opmerkingDetail: "",
          image:
            "https://images.unsplash.com/photo-1599566150163-29194dcaad36?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxwaG90by1wYWdlfHx8fGVufDB8fHx8&auto=format&fit=crop&w=687&q=80",
          role: "1",
        },
      ],
      instructions: [],
      remarks: [
        {
          id: 0,
          user_id: 0,
          status: "solved",
          body: "Vestibulum sed arcu non odio euismod lacinia at. Nisl suscipit adipiscing bibendum est. Praesent tristique magna sit amet purus. Mattis ullamcorper velit sed ullamcorper morbi tincidunt.",
        },
        {
          id: 1,
          user_id: 2,
          status: "conflict",
          body: "euismod nisi. Urna condimentum mattis pellentesque id nibh tortor. In cursus turpis",
          comments: [
            {
              user_id: 2,
              body: "Dictumst vestibulum rhoncus est pellentesque. Odio pellentesque diam volutpat commodo sed. Cursus risus at ultrices mi tempus imperdiet nulla.",
            },
            {
              user_id: 0,
              body: "Dictumst vestibulum rhoncus est pellentesque. Odio pellentesque diam volutpat commodo sed. Cursus risus at ultrices mi tempus imperdiet nulla.",
            },
          ],
        },
        {
          id: 2,
          user_id: 1,
          status: "conflict",
          body: "Dictumst vestibulum rhoncus est pellentesque. Odio pellentesque diam volutpat commodo sed. Cursus risus at ultrices mi tempus imperdiet nulla.",
        },
        {
          id: 3,
          user_id: 2,
          status: "solved",
          body: "Ultrices dui sapien eget mi proin sed libero. Proin sagittis nisl rhoncus mattis rhoncus urna neque viverra justo. ",
          comments: [
            {
              user_id: 2,
              body: "Dictumst vestibulum rhoncus est pellentesque. Odio pellentesque diam volutpat commodo sed. Cursus risus at ultrices mi tempus imperdiet nulla.",
            },
          ],
        },
        {
          id: 4,
          user_id: 0,
          status: "conflict",
          body: "Risus quis varius quam quisque id. Elit scelerisque mauris pellentesque pulvinar pellentesque habitant. Gravida neque convallis a cras semper auctor neque vitae. Venenatis lectus magna fringilla urna.",
        },
      ],
      students: [],
      superStudents: [],
      codes: [],
      activeStepIndex: 0,
      activeStepIndexCodes: 0,
      activeFilter: "conflict",
      items: [],
      currentSessionId: null,
      index: null,
    };
  },
  props: ["id"],
  created() {
    this.getBuildingDetails();
    this.filterStudents();
  },
  methods: {
    filterStudents() {
      this.users.forEach((user) => {
        if (user.role == 1) {
          this.superStudents.push(user);
        } else {
          this.students.push(user);
        }
      });
    },
    goToEdit() {
      this.$router.push({
        name: "editBuildings",
        params: { id: this.$route.params.id },
      });
    },
    async getBuildingDetails() {
      store.commit("general/setLoading", true);
      try {
        await axios
          .get("/api/building/" + this.$route.params.id)
          .then((response) => {
            if (response.status === 200) {
              this.buildingData = response.data;
            }
          });
      } catch (error) {
        console.log(error);
      }
      //this.addMockData();
      store.commit("general/setLoading", false);
      if (this.buildingData.instructionsString !== null) {
        //remove trailing comma
        //replace all single quotes with double quotes
        this.instructions = JSON.parse(
          "[" +
            this.buildingData.instructionsString
              .slice(0, -1)
              .replace(/'/g, '"') +
            "]"
        );
      }
      if (this.buildingData.codes !== null) {
        //remove trailing comma
        //replace all single quotes with double quotes
        this.codes = JSON.parse(
          "[" + this.buildingData.codes.slice(0, -1).replace(/'/g, '"') + "]"
        );
      }
      this.getBuildingImages();
    },
    async getBuildingImages() {
      await this.getCurrentSession();
      await this.getSessionImages();
    },
    async getCurrentSession() {
      await axios
        .post("/api/sessions", { day: new Date().toISOString() })
        .then((response) => {
          if (response.status === 200) {
            console.log(response.data);
            var ids = response.data
              .filter((o) => o.roundId == this.buildingData.round.id)
              ?.map((o) => o.id);
            if (ids.length >= 2) {
              this.currentSessionId = ids[1];
            } else {
              this.currentSessionId = ids[0];
            }

            console.log(this.currentSessionId);
          }
          store.commit("general/setLoading", false);
        });
    },
    async getSessionImages() {
      console.log(this.currentSessionId);
      await axios
        .get("/api/session/detail/" + this.currentSessionId)
        .then((response) => {
          this.items = [];
          var images = response.data.buildingSessions.find(
            (s) => s.buildingId == this.buildingData.id
          )?.images;
          images.forEach((i) => {
            this.items.push({
              url: "/api/image?name=test.png&uri=" + i.originalUrl,
              date: new Date(i.createdAt),
            });
          });
        });
    },
    confirmate() {
      this.confirm = true;
    },
    editBuilding() {
      this.$router.push({
        name: "editBuildings",
        params: { id: this.buildingData.id },
      });
    },
    async deleteBuilding() {
      await axios
        .delete("/api/building/" + this.buildingData.id)
        .then((response) => {
          if (response.status === 200) {
            console.log("deleted");
            this.$router.push({
              name: "buildings",
            });
          }
        });
    },
    splitAddress(address) {
      const parts = address?.split(", ");
      var street = "";
      var number = "";
      var streetAndNumber = "";
      if (parts) {
        streetAndNumber = parts[0].split(" ");
        street = streetAndNumber.slice(0, -1).join(" ");
        number = streetAndNumber.slice(-1)[0];
      }

      return {
        streetAndNumber: `${street} ${number}`,
      };
    },
  },
  computed: {
    filteredRemarks() {
      return this.remarks.filter(
        (remark) => remark.status === this.activeFilter
      );
    },
  },
};
</script>

<style lang="scss" scoped>
@import "../assets/css/base.css";
@import "../assets/css/colors.css";
.images-container {
  img {
    border: 2px solid var(--light-grey);
    border-radius: 10px;
    object-fit: cover;
    width: 100%;
    aspect-ratio: 1/1;
  }
  .upload {
    color: var(--light-grey);
  }
}
.route-image {
  object-fit: cover;
  width: 50%;
}

.profile-picture {
  border-radius: 50%;
  min-width: 50px;
  max-width: 80px;
  height: 100%;
  aspect-ratio: 1.5/1;
  object-fit: cover;
  &__small {
    border-radius: 50%;
    min-width: 40px;
    max-width: 60px;
    height: 100%;
    aspect-ratio: 1.5/1;
  }
}

.icons {
  width: 35px;
  height: 35px;
  padding-left: 6px;
  padding-right: 6px;
}
.point :hover {
  cursor: pointer;
}

.text-gray {
  color: #a5a5a5;
}

.map {
  width: 100%;
  min-height: 404px;
  background: rgba(lightblue, 0.5);
  background-image: url("https://static.joomlart.com/images/blog/2018/ja-open-street-map-101/transport-map.jpg");
  background-repeat: no-repeat;
  background-size: cover;
}

.building-item {
  transition: all 400ms;
  border-top: solid var(--light-grey) 1px;
  &:last-child {
    border-bottom: solid var(--light-grey) 1px;
  }
  &.active-building {
    background-color: var(--almost-white);
  }

  &__link {
    color: var(--almost-black);
    &:hover {
      color: var(--light-grey);
    }
  }
}

.tab-filter {
  border-bottom: 1px var(--light-grey) solid;
  &__tab {
    &.active {
      color: var(--grey);
      font-weight: 500;
      border-bottom: 2px var(--grey) solid;
    }
  }
}

.remark {
  border: 1px solid var(--light-grey);
}

#map {
  width: 50%;
}
</style>
